/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TramoDAO;
import com.rjconsultores.ventaboletos.dao.ViaDAO;
import com.rjconsultores.ventaboletos.entidad.Via;
import com.rjconsultores.ventaboletos.service.ViaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("viaService")
public class ViaServiceImpl implements ViaService {

    @Autowired
    private ViaDAO viaDAO;
    @Autowired
    private TramoDAO tramoDAO;

    public List<Via> obtenerTodos() {
        return viaDAO.obtenerTodos();
    }

    public Via obtenerID(Integer id) {
        return viaDAO.obtenerID(id);
    }

    @Transactional
    public Via suscribir(Via entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return viaDAO.suscribir(entidad);
    }

    @Transactional
    public Via actualizacion(Via entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return viaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Via entidad) throws RegistroConDependenciaException {
        if (tramoDAO.count("via", entidad) > 0l) {
            throw new RegistroConDependenciaException();
        }
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        viaDAO.actualizacion(entidad);
    }

    public List<Via> buscar(String nombvia) {
        return viaDAO.buscar(nombvia);
    }
}
